%
%   Note the change in the op dir at the very end, should be writing to a
%   folder specific to each flow al
%

% write training data to file
clear all;

test = 1; % if test ==1, no gt and dont want training files
noScenes = 30;
sceneID = 5;
dir  = ['../data/' sceneID];
opDir = ['../data/'];

fvFile = 'fv'
%al = 'tv';%, 2 tv, 3 hs, 4 fl
flowError = 0.25;
sizeLimit = 7000;
for al = {'fl'}%{'ba', 'tv', 'hs', 'fl'}
    for testId = [1:noScenes]
        al = char(al);
        sequences = [1:noScenes];
        
        %% training data
        if (test == 0)
            sequences = [1:noScenes];        
            sequences(sequences == testId) = [];
            for i=sequences
                load([dir num2str(i) '/' num2str(i)])
                load([dir num2str(i) '/' num2str(i) fvFile])
                
                % get error
                if(al == 'ba')
                    [angBA errVal] = flowAngErrMe(tuv(:,:,1), tuv(:,:,2), uvBA(:,:,1), uvBA(:,:,2));
                    data(:, [42,43,44]) = [];
                elseif (al == 'tv')
                    [angTV errVal] = flowAngErrMe(tuv(:,:,1), tuv(:,:,2), uvTV(:,:,1), uvTV(:,:,2));
                    data(:, [41,43,44]) = [];
                elseif (al == 'hs')
                    [angHS errVal] = flowAngErrMe(tuv(:,:,1), tuv(:,:,2), uvHS(:,:,1), uvHS(:,:,2));
                    data(:, [41,42,44]) = [];
                elseif (al == 'fl')
                    [angFL errVal] = flowAngErrMe(tuv(:,:,1), tuv(:,:,2), uvFL(:,:,1), uvFL(:,:,2));
                    data(:, [41,42,43]) = [];
                end
                
                % labels - 0 if hard to flow, 1 otherwise
                labels = ~((errVal > flowError) | (mask == 0))';
                labels = labels(:);
                
                % want equal contribution from each class
                hardToOF = data(labels==0,:);
                easyToOF = data(labels==1,:);
                
                % shuffle
                amt  = min([size(hardToOF,1) size(easyToOF,1) sizeLimit]);
                
                shuff = randperm(size(hardToOF,1));
                hardToOF = hardToOF(shuff(1:amt),:);
                
                shuff = randperm(size(easyToOF,1));
                easyToOF = easyToOF(shuff(1:amt),:);
                
                %labelsComb = labels(shuff(1:sizeLimit));
                
                % write training data
                dlmwrite([opDir al '/' num2str(testId) '_Train.data'], [zeros(amt,1) hardToOF; ones(amt,1) easyToOF], '-append');
            end
        end
        
        %% test data
        % write test data to file - left to right (row major order)
        load([dir num2str(testId) '/' num2str(testId)])
        load([dir num2str(testId) '/' num2str(testId) fvFile])
        if (test == 0)            
            if(al == 'ba')
                [angBA errVal] = flowAngErrMe(tuv(:,:,1), tuv(:,:,2), uvBA(:,:,1), uvBA(:,:,2));
                data(:, [42,43,44]) = [];
            elseif (al == 'tv')
                [angTV errVal] = flowAngErrMe(tuv(:,:,1), tuv(:,:,2), uvTV(:,:,1), uvTV(:,:,2));
                data(:, [41,43,44]) = [];
            elseif (al == 'hs')
                [angHS errVal] = flowAngErrMe(tuv(:,:,1), tuv(:,:,2), uvHS(:,:,1), uvHS(:,:,2));
                data(:, [41,42,44]) = [];
            elseif (al == 'fl')
                [angFL errVal] = flowAngErrMe(tuv(:,:,1), tuv(:,:,2), uvFL(:,:,1), uvFL(:,:,2));
                data(:, [41,42,43]) = [];
            end
            labels = ~((errVal > flowError) | (mask == 0))';
            labels = labels(:);
        else
            % No GT Labels
            labels = zeros(size(data,1),1);
            if(al == 'ba')
                data(:, [42,43,44]) = [];
            elseif (al == 'tv')
                data(:, [41,43,44]) = [];
            elseif (al == 'hs')
                data(:, [41,42,44]) = [];
            elseif (al == 'fl')
                data(:, [41,42,43]) = [];
            end
        end
        dlmwrite([opDir '/' num2str(testId) '_Test.data'], [labels data]);
        
    end
end